#include "easygen.h"
#include "easygen.cpp"

#include <algorithm>
#include <iostream>
#include <string>

using namespace std;

const int maxn = 1010;
const int maxM = 100010;

int n, m;
int u[maxM], v[maxM], p[maxn];
int vis[maxn][maxn];

int main(int argc, char* argv[])
{
   int i, j;

   try {
      testInfo a(argc, argv);
      n = a.getIntParam("N");
      m = a.getIntParam("M");

      for (i = 1; i <= n-1; i++) {
         u[i] = i;
         v[i] = i+1;
         vis[i][i+1] = 1;
      }
      for (i = n; i <= m; i++) {
         do {
            u[i] = genRandInt(1, n-1);
            v[i] = genRandInt(u[i]+1, n);
         } while (vis[u[i]][v[i]]);
         vis[u[i]][v[i]] = 1;
      }
      
      for (i = 1; i <= n; i++) 
         p[i] = i;
      for (i = 1; i <= n; i++) {
         int n1 = genRandInt(1, n);
         int n2 = genRandInt(1, n);
         swap(p[n1], p[n2]);
      }

      for (i = 1; i <= m; i++) {
         a["a"][i]["u"] = p[u[i]];
         a["a"][i]["v"] = p[v[i]];
      }

   } catch (genError a) {
      cout << a.err();
   }
   return 0;
}
