#include "string.h"
#include "stdlib.h"
#include "stdio.h"
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

const int maxn = 1010;
const int maxM = 100010;

int n, m, k, num;
int g[maxn], u[maxM], v[maxM], nxt[maxM];
int vis[maxn], ans[maxn];

void add(int i)
{
   nxt[i] = g[u[i]]; g[u[i]] = i;
}

void dfs(int x)
{
   vis[x] = 1;
   int i = g[x];
   while (i) {
      if (!vis[v[i]]) dfs(v[i]);
      i = nxt[i];
   }
   ans[num++] = x;
}

int main()
{
   freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);

   int i, j;
   cin >> n >> m;
   for (i = 1; i <= m; i++) {
      cin >> u[i] >> v[i];
      add(i);
   }

   num = 0;
   for (i = 1; i <= n; i++)
      if (!vis[i]) dfs(i);

   int ok = 1;
   for (i = 1; i < n; i++) {
      j = g[ans[i]];
      ok = 0;
      while (j) {
         if (v[j] == ans[i-1]) ok = 1;
         j = nxt[j];
      }
      if (!ok) break;
   }

   if (ok) {
      for (i = n-1; i >= 0; i--) cout << ans[i] << " ";
   } else cout << 0;
   fclose(stdin); fclose(stdout);
   return 0;
}

